/* ease-dialogs.c generated by valac, the Vala compiler
 * generated from ease-dialogs.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define EASE_TYPE_OPEN_DIALOG (ease_open_dialog_get_type ())
#define EASE_OPEN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_OPEN_DIALOG, EaseOpenDialog))
#define EASE_OPEN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_OPEN_DIALOG, EaseOpenDialogClass))
#define EASE_IS_OPEN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_OPEN_DIALOG))
#define EASE_IS_OPEN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_OPEN_DIALOG))
#define EASE_OPEN_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_OPEN_DIALOG, EaseOpenDialogClass))

typedef struct _EaseOpenDialog EaseOpenDialog;
typedef struct _EaseOpenDialogClass EaseOpenDialogClass;
typedef struct _EaseOpenDialogPrivate EaseOpenDialogPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _EaseOpenDialog {
	GObject parent_instance;
	EaseOpenDialogPrivate * priv;
};

struct _EaseOpenDialogClass {
	GObjectClass parent_class;
};


static gpointer ease_open_dialog_parent_class = NULL;

GType ease_open_dialog_get_type (void) G_GNUC_CONST;
enum  {
	EASE_OPEN_DIALOG_DUMMY_PROPERTY
};
void ease_main_open_file (const char* path);
void ease_open_dialog_run (void);
EaseOpenDialog* ease_open_dialog_new (void);
EaseOpenDialog* ease_open_dialog_construct (GType object_type);
char* save_dialog (const char* title, GtkWindow* modal);



/**
 * Displays an "Open" dialog.
 * 
 * Used for loading previously saved files. This is a static method.
 */
#line 28 "ease-dialogs.vala"
void ease_open_dialog_run (void) {
#line 74 "ease-dialogs.c"
	GtkFileChooserDialog* dialog;
	GtkFileFilter* filter;
#line 30 "ease-dialogs.vala"
	dialog = g_object_ref_sink ((GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Open File"), NULL, GTK_FILE_CHOOSER_ACTION_OPEN, "gtk-cancel", GTK_RESPONSE_CANCEL, "gtk-open", GTK_RESPONSE_ACCEPT, NULL));
#line 39 "ease-dialogs.vala"
	filter = g_object_ref_sink (gtk_file_filter_new ());
#line 40 "ease-dialogs.vala"
	gtk_file_filter_add_pattern (filter, "*.ease");
#line 41 "ease-dialogs.vala"
	gtk_file_chooser_set_filter ((GtkFileChooser*) dialog, filter);
#line 43 "ease-dialogs.vala"
	if (gtk_dialog_run ((GtkDialog*) dialog) == GTK_RESPONSE_ACCEPT) {
#line 87 "ease-dialogs.c"
		char* _tmp1_;
		char* _tmp0_;
#line 45 "ease-dialogs.vala"
		ease_main_open_file (_tmp1_ = g_strconcat (_tmp0_ = gtk_file_chooser_get_filename ((GtkFileChooser*) dialog), "/", NULL));
#line 92 "ease-dialogs.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
	}
#line 47 "ease-dialogs.vala"
	gtk_object_destroy ((GtkObject*) dialog);
#line 98 "ease-dialogs.c"
	_g_object_unref0 (filter);
	_g_object_unref0 (dialog);
}


#line 21 "ease-dialogs.vala"
EaseOpenDialog* ease_open_dialog_construct (GType object_type) {
#line 106 "ease-dialogs.c"
	EaseOpenDialog * self;
#line 21 "ease-dialogs.vala"
	self = (EaseOpenDialog*) g_object_new (object_type, NULL);
#line 110 "ease-dialogs.c"
	return self;
}


#line 21 "ease-dialogs.vala"
EaseOpenDialog* ease_open_dialog_new (void) {
#line 21 "ease-dialogs.vala"
	return ease_open_dialog_construct (EASE_TYPE_OPEN_DIALOG);
#line 119 "ease-dialogs.c"
}


static void ease_open_dialog_class_init (EaseOpenDialogClass * klass) {
	ease_open_dialog_parent_class = g_type_class_peek_parent (klass);
}


static void ease_open_dialog_instance_init (EaseOpenDialog * self) {
}


/**
 * Creates "open file" windows.
 */
GType ease_open_dialog_get_type (void) {
	static volatile gsize ease_open_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&ease_open_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseOpenDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_open_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseOpenDialog), 0, (GInstanceInitFunc) ease_open_dialog_instance_init, NULL };
		GType ease_open_dialog_type_id;
		ease_open_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "EaseOpenDialog", &g_define_type_info, 0);
		g_once_init_leave (&ease_open_dialog_type_id__volatile, ease_open_dialog_type_id);
	}
	return ease_open_dialog_type_id__volatile;
}


/**
 * Creates and runs a "save" dialog with the given title. Returns null if
 * cancelled, otherwise returns the selected path
 *
 * @param title The dialog's title.
 * @param modal The window that the dialog should be modal for.
 */
#line 58 "ease-dialogs.vala"
char* save_dialog (const char* title, GtkWindow* modal) {
#line 156 "ease-dialogs.c"
	char* result = NULL;
	GtkFileChooserDialog* dialog;
#line 58 "ease-dialogs.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 60 "ease-dialogs.vala"
	dialog = g_object_ref_sink ((GtkFileChooserDialog*) gtk_file_chooser_dialog_new (title, modal, GTK_FILE_CHOOSER_ACTION_SAVE, "gtk-save", GTK_RESPONSE_ACCEPT, "gtk-cancel", GTK_RESPONSE_CANCEL, NULL, NULL));
#line 69 "ease-dialogs.vala"
	if (gtk_dialog_run ((GtkDialog*) dialog) == GTK_RESPONSE_ACCEPT) {
#line 165 "ease-dialogs.c"
		char* path;
#line 72 "ease-dialogs.vala"
		path = gtk_file_chooser_get_filename ((GtkFileChooser*) dialog);
#line 73 "ease-dialogs.vala"
		gtk_object_destroy ((GtkObject*) dialog);
#line 171 "ease-dialogs.c"
		result = path;
		_g_object_unref0 (dialog);
#line 74 "ease-dialogs.vala"
		return result;
#line 176 "ease-dialogs.c"
	} else {
#line 78 "ease-dialogs.vala"
		gtk_object_destroy ((GtkObject*) dialog);
#line 180 "ease-dialogs.c"
		result = NULL;
		_g_object_unref0 (dialog);
#line 79 "ease-dialogs.vala"
		return result;
#line 185 "ease-dialogs.c"
	}
	_g_object_unref0 (dialog);
}




