/* ease-temp.c generated by valac, the Vala compiler
 * generated from ease-temp.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <archive.h>
#include <archive_entry.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <glib/gi18n-lib.h>


#define EASE_TYPE_TEMP (ease_temp_get_type ())
#define EASE_TEMP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_TEMP, EaseTemp))
#define EASE_TEMP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_TEMP, EaseTempClass))
#define EASE_IS_TEMP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_TEMP))
#define EASE_IS_TEMP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_TEMP))
#define EASE_TEMP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_TEMP, EaseTempClass))

typedef struct _EaseTemp EaseTemp;
typedef struct _EaseTempClass EaseTempClass;
typedef struct _EaseTempPrivate EaseTempPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _archive_read_finish0(var) ((var == NULL) ? NULL : (var = (archive_read_finish (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _archive_entry_free0(var) ((var == NULL) ? NULL : (var = (archive_entry_free (var), NULL)))
#define _archive_write_finish0(var) ((var == NULL) ? NULL : (var = (archive_write_finish (var), NULL)))
typedef struct _Block19Data Block19Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _EaseTemp {
	GObject parent_instance;
	EaseTempPrivate * priv;
};

struct _EaseTempClass {
	GObjectClass parent_class;
};

typedef void (*EaseRecursiveDirAction) (const char* path, const char* full_path, void* user_data, GError** error);
struct _Block19Data {
	int _ref_count_;
	struct archive* archive;
	gchar* buffer;
	gint buffer_length1;
	gint _buffer_size_;
};


static gint ease_temp_index;
static gint ease_temp_index = 0;
static char* ease_temp_m_temp;
static char* ease_temp_m_temp = NULL;
static GeeLinkedList* ease_temp_m_dirs;
static GeeLinkedList* ease_temp_m_dirs = NULL;
static gpointer ease_temp_parent_class = NULL;

GType ease_temp_get_type (void) G_GNUC_CONST;
enum  {
	EASE_TEMP_DUMMY_PROPERTY
};
#define EASE_TEMP_ARCHIVE_BUFFER 4096
#define EASE_TEMP_TEMP_DIR "ease"
#define EASE_TEMP_THEME_DIR "themes"
#define EASE_TEMP_IMG_DIR "svg"
#define EASE_TEMP_UI_DIR "ui"
gboolean ease_temp_exists (gint dir, const char* tmp);
static const char* ease_temp_get_temp (void);
static GeeLinkedList* ease_temp_get_dirs (void);
char* ease_temp_request (GError** error);
char* ease_temp_request_str (const char* str, GError** error);
char* ease_temp_extract (const char* filename, GError** error);
void ease_recursive_directory (const char* directory, EaseRecursiveDirAction directory_action, void* directory_action_target, EaseRecursiveDirAction file_action, void* file_action_target, GError** error);
static void ease_temp_arc_fail (int _result_, struct archive* archive);
static void _lambda19_ (const char* path, const char* full_path, Block19Data* _data19_, GError** error);
static void __lambda19__ease_recursive_dir_action (const char* path, const char* full_path, gpointer self, GError** error);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (Block19Data* _data19_);
void ease_temp_archive (const char* temp_path, const char* filename, GError** error);
void ease_recursive_delete (const char* path, GError** error);
void ease_temp_clean (void);
EaseTemp* ease_temp_new (void);
EaseTemp* ease_temp_construct (GType object_type);
static void ease_temp_finalize (GObject* obj);
static void ease_temp_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);



/**
 * Requests a temporary directory.
 *
 * request() creates a temporary directory (typically under /tmp/ease).
 * Each directory has a integer name, incrementing by one for each new
 * directory.
 */
#line 70 "ease-temp.vala"
char* ease_temp_request (GError** error) {
#line 123 "ease-temp.c"
	char* result = NULL;
	GError * _inner_error_;
	char* _tmp0_;
	char* _tmp1_;
	char* tmp;
	GFile* file;
	_inner_error_ = NULL;
#line 73 "ease-temp.vala"
	while (TRUE) {
#line 73 "ease-temp.vala"
		if (!ease_temp_exists (ease_temp_index, ease_temp_get_temp ())) {
#line 73 "ease-temp.vala"
			break;
#line 137 "ease-temp.c"
		}
#line 75 "ease-temp.vala"
		ease_temp_index++;
#line 141 "ease-temp.c"
	}
#line 79 "ease-temp.vala"
	tmp = (_tmp1_ = g_build_filename (ease_temp_get_temp (), _tmp0_ = g_strdup_printf ("%i", ease_temp_index), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 82 "ease-temp.vala"
	gee_deque_offer_head ((GeeDeque*) ease_temp_get_dirs (), tmp);
#line 85 "ease-temp.vala"
	file = g_file_new_for_path (tmp);
#line 86 "ease-temp.vala"
	g_file_make_directory_with_parents (file, NULL, &_inner_error_);
#line 151 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		_g_free0 (tmp);
		return NULL;
	}
	result = tmp;
	_g_object_unref0 (file);
#line 88 "ease-temp.vala"
	return result;
#line 162 "ease-temp.c"
}


/**
 * Requests a temporary directory with a specific name.
 *
 * This function is useful for debugging and cleanliness purposes.
 * However, be sure to use unique names. Do not use "integer" strings,
 * as those could overlap with directories created through request().
 * For this reason, this function is not available to code outside
 * Ease.
 *
 * @param str The directory name to request.
 */
#line 102 "ease-temp.vala"
char* ease_temp_request_str (const char* str, GError** error) {
#line 179 "ease-temp.c"
	char* result = NULL;
	GError * _inner_error_;
	char* tmp;
	GFile* file;
#line 102 "ease-temp.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 186 "ease-temp.c"
	_inner_error_ = NULL;
#line 105 "ease-temp.vala"
	tmp = g_build_filename (ease_temp_get_temp (), str, NULL);
#line 108 "ease-temp.vala"
	gee_deque_offer_head ((GeeDeque*) ease_temp_get_dirs (), tmp);
#line 111 "ease-temp.vala"
	file = g_file_new_for_path (tmp);
#line 112 "ease-temp.vala"
	g_file_make_directory_with_parents (file, NULL, &_inner_error_);
#line 196 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		_g_free0 (tmp);
		return NULL;
	}
	result = tmp;
	_g_object_unref0 (file);
#line 114 "ease-temp.vala"
	return result;
#line 207 "ease-temp.c"
}


/**
 * Creates a temporary directory and extracts an archive to it.
 *
 * extract() uses libarchive for extraction. It will automatically request
 * a new temporary directory, extract the archive, and return the path
 * to the extracted files.
 *
 * @param filename The path of the archive to extract.
 */
#line 126 "ease-temp.vala"
char* ease_temp_extract (const char* filename, GError** error) {
#line 222 "ease-temp.c"
	char* result = NULL;
	GError * _inner_error_;
	struct archive* archive;
	char* path;
	struct archive_entry* entry;
#line 126 "ease-temp.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 230 "ease-temp.c"
	_inner_error_ = NULL;
#line 129 "ease-temp.vala"
	archive = archive_read_new ();
#line 132 "ease-temp.vala"
	archive_read_support_compression_all (archive);
#line 133 "ease-temp.vala"
	archive_read_support_format_all (archive);
#line 136 "ease-temp.vala"
	archive_read_open_filename (archive, filename, (gsize) EASE_TEMP_ARCHIVE_BUFFER);
#line 139 "ease-temp.vala"
	path = ease_temp_request (&_inner_error_);
#line 242 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_archive_read_finish0 (archive);
		return NULL;
	}
	entry = NULL;
#line 143 "ease-temp.vala"
	while (TRUE) {
#line 251 "ease-temp.c"
		char* fpath;
		GFile* file;
#line 143 "ease-temp.vala"
		if (!(archive_read_next_header (archive, &entry) == ARCHIVE_OK)) {
#line 143 "ease-temp.vala"
			break;
#line 258 "ease-temp.c"
		}
#line 145 "ease-temp.vala"
		fpath = g_build_filename (path, archive_entry_pathname (entry), NULL);
#line 146 "ease-temp.vala"
		file = g_file_new_for_path (fpath);
#line 148 "ease-temp.vala"
		if (S_ISDIR (archive_entry_mode (entry))) {
#line 150 "ease-temp.vala"
			g_file_make_directory_with_parents (file, NULL, &_inner_error_);
#line 268 "ease-temp.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (file);
				_g_free0 (fpath);
				_g_free0 (path);
				_archive_read_finish0 (archive);
				return NULL;
			}
		} else {
			GFile* parent;
			GFileOutputStream* _tmp0_;
			gint fd;
#line 154 "ease-temp.vala"
			parent = g_file_get_parent (file);
#line 155 "ease-temp.vala"
			if (!g_file_query_exists (parent, NULL)) {
#line 157 "ease-temp.vala"
				g_file_make_directory_with_parents (parent, NULL, &_inner_error_);
#line 287 "ease-temp.c"
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (parent);
					_g_object_unref0 (file);
					_g_free0 (fpath);
					_g_free0 (path);
					_archive_read_finish0 (archive);
					return NULL;
				}
			}
#line 160 "ease-temp.vala"
			_tmp0_ = g_file_create (file, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 300 "ease-temp.c"
			_g_object_unref0 (_tmp0_);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (parent);
				_g_object_unref0 (file);
				_g_free0 (fpath);
				_g_free0 (path);
				_archive_read_finish0 (archive);
				return NULL;
			}
#line 161 "ease-temp.vala"
			fd = open (fpath, O_WRONLY, (mode_t) 0644);
#line 162 "ease-temp.vala"
			archive_read_data_into_fd (archive, fd);
#line 163 "ease-temp.vala"
			close (fd);
#line 317 "ease-temp.c"
			_g_object_unref0 (parent);
		}
		_g_object_unref0 (file);
		_g_free0 (fpath);
	}
	result = path;
	_archive_read_finish0 (archive);
#line 167 "ease-temp.vala"
	return result;
#line 327 "ease-temp.c"
}


#line 205 "ease-temp.vala"
static void _lambda19_ (const char* path, const char* full_path, Block19Data* _data19_, GError** error) {
#line 333 "ease-temp.c"
	struct archive_entry* entry;
	struct stat st = {0};
	gint fd;
	gssize len;
#line 205 "ease-temp.vala"
	g_return_if_fail (path != NULL);
#line 205 "ease-temp.vala"
	g_return_if_fail (full_path != NULL);
#line 207 "ease-temp.vala"
	entry = archive_entry_new ();
#line 208 "ease-temp.vala"
	archive_entry_set_pathname (entry, path);
#line 209 "ease-temp.vala"
	archive_entry_set_perm (entry, (mode_t) 0644);
#line 211 "ease-temp.vala"
	stat (full_path, &st);
#line 212 "ease-temp.vala"
	archive_entry_copy_stat (entry, &st);
#line 213 "ease-temp.vala"
	ease_temp_arc_fail (archive_write_header (_data19_->archive, entry), _data19_->archive);
#line 216 "ease-temp.vala"
	fd = open (full_path, O_RDONLY, 0);
#line 217 "ease-temp.vala"
	len = read (fd, _data19_->buffer, (gsize) (sizeof (gchar) * EASE_TEMP_ARCHIVE_BUFFER));
#line 218 "ease-temp.vala"
	while (TRUE) {
#line 218 "ease-temp.vala"
		if (!(len > 0)) {
#line 218 "ease-temp.vala"
			break;
#line 364 "ease-temp.c"
		}
#line 220 "ease-temp.vala"
		archive_write_data (_data19_->archive, _data19_->buffer, (gsize) len);
#line 221 "ease-temp.vala"
		len = read (fd, _data19_->buffer, (gsize) (sizeof (gchar) * EASE_TEMP_ARCHIVE_BUFFER));
#line 370 "ease-temp.c"
	}
#line 223 "ease-temp.vala"
	close (fd);
#line 224 "ease-temp.vala"
	ease_temp_arc_fail (archive_write_finish_entry (_data19_->archive), _data19_->archive);
#line 376 "ease-temp.c"
	_archive_entry_free0 (entry);
}


#line 205 "ease-temp.vala"
static void __lambda19__ease_recursive_dir_action (const char* path, const char* full_path, gpointer self, GError** error) {
#line 383 "ease-temp.c"
	_lambda19_ (path, full_path, self, error);
}


static Block19Data* block19_data_ref (Block19Data* _data19_) {
	g_atomic_int_inc (&_data19_->_ref_count_);
	return _data19_;
}


static void block19_data_unref (Block19Data* _data19_) {
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
		_data19_->buffer = (g_free (_data19_->buffer), NULL);
		_archive_write_finish0 (_data19_->archive);
		g_slice_free (Block19Data, _data19_);
	}
}


/**
 * Creates an archive from a temporary directory.
 *
 * archive() uses libarchive to create a tarball of the temporary directory.
 *
 * @param temp_path The path of the temporary directory.
 * @param filename The filename of the archive to save to.
 */
#line 178 "ease-temp.vala"
void ease_temp_archive (const char* temp_path, const char* filename, GError** error) {
#line 413 "ease-temp.c"
	GError * _inner_error_;
	Block19Data* _data19_;
	gchar* _tmp0_;
	GDir* dir;
#line 178 "ease-temp.vala"
	g_return_if_fail (temp_path != NULL);
#line 178 "ease-temp.vala"
	g_return_if_fail (filename != NULL);
#line 422 "ease-temp.c"
	_inner_error_ = NULL;
	_data19_ = g_slice_new0 (Block19Data);
	_data19_->_ref_count_ = 1;
	_data19_->archive = archive_write_new ();
	_data19_->buffer = (_tmp0_ = g_new0 (gchar, EASE_TEMP_ARCHIVE_BUFFER), _data19_->buffer_length1 = EASE_TEMP_ARCHIVE_BUFFER, _tmp0_);
#line 185 "ease-temp.vala"
	archive_write_set_format_pax_restricted (_data19_->archive);
#line 186 "ease-temp.vala"
	archive_write_set_compression_none (_data19_->archive);
#line 189 "ease-temp.vala"
	if (archive_write_open_filename (_data19_->archive, filename) == ARCHIVE_FAILED) {
#line 434 "ease-temp.c"
		_inner_error_ = g_error_new ((GQuark) 0, 0, "Error opening %s", filename);
		{
			g_propagate_error (error, _inner_error_);
			block19_data_unref (_data19_);
			return;
		}
	}
#line 195 "ease-temp.vala"
	dir = g_dir_open (temp_path, (guint) 0, &_inner_error_);
#line 444 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		block19_data_unref (_data19_);
		return;
	}
#line 198 "ease-temp.vala"
	if (dir == NULL) {
#line 452 "ease-temp.c"
		_inner_error_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_NOENT, _ ("Temporary directory doesn't exist: %s"), temp_path);
		{
			g_propagate_error (error, _inner_error_);
			_g_dir_close0 (dir);
			block19_data_unref (_data19_);
			return;
		}
	}
#line 205 "ease-temp.vala"
	ease_recursive_directory (temp_path, NULL, NULL, __lambda19__ease_recursive_dir_action, _data19_, &_inner_error_);
#line 463 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_dir_close0 (dir);
		block19_data_unref (_data19_);
		return;
	}
#line 228 "ease-temp.vala"
	ease_temp_arc_fail (archive_write_close (_data19_->archive), _data19_->archive);
#line 472 "ease-temp.c"
	_g_dir_close0 (dir);
	block19_data_unref (_data19_);
}


/**
 * Produces an error if a libarchive error occurs.
 */
#line 234 "ease-temp.vala"
static void ease_temp_arc_fail (int _result_, struct archive* archive) {
#line 234 "ease-temp.vala"
	g_return_if_fail (archive != NULL);
#line 236 "ease-temp.vala"
	if (_result_ != ARCHIVE_OK) {
#line 236 "ease-temp.vala"
		g_error ("ease-temp.vala:236: %s", archive_error_string (archive));
#line 489 "ease-temp.c"
	}
}


/**
 * Deletes all temporary directories created by this instance of Ease.
 * Call when exiting.
 */
#line 243 "ease-temp.vala"
void ease_temp_clean (void) {
#line 500 "ease-temp.c"
	GError * _inner_error_;
	char* dir;
	char* tmp;
	_inner_error_ = NULL;
#line 245 "ease-temp.vala"
	if (ease_temp_get_dirs () == NULL) {
#line 245 "ease-temp.vala"
		return;
#line 509 "ease-temp.c"
	}
	dir = NULL;
#line 248 "ease-temp.vala"
	while (TRUE) {
#line 514 "ease-temp.c"
		char* _tmp0_;
#line 248 "ease-temp.vala"
		if (!((dir = (_tmp0_ = (char*) gee_deque_poll_head ((GeeDeque*) ease_temp_get_dirs ()), _g_free0 (dir), _tmp0_)) != NULL)) {
#line 248 "ease-temp.vala"
			break;
#line 520 "ease-temp.c"
		}
		{
#line 250 "ease-temp.vala"
			ease_recursive_delete (dir, &_inner_error_);
#line 525 "ease-temp.c"
			if (_inner_error_ != NULL) {
				goto __catch20_g_error;
			}
		}
		goto __finally20;
		__catch20_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 253 "ease-temp.vala"
				g_debug ("ease-temp.vala:253: %s", e->message);
#line 539 "ease-temp.c"
				_g_error_free0 (e);
			}
		}
		__finally20:
		if (_inner_error_ != NULL) {
			_g_free0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 261 "ease-temp.vala"
	tmp = g_build_filename (g_get_tmp_dir (), EASE_TEMP_TEMP_DIR, NULL);
#line 553 "ease-temp.c"
	{
		GFile* file;
		GFile* _tmp1_;
#line 265 "ease-temp.vala"
		file = g_file_new_for_path (ease_temp_get_temp ());
#line 266 "ease-temp.vala"
		g_file_delete (file, NULL, &_inner_error_);
#line 561 "ease-temp.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			goto __catch21_g_error;
		}
#line 269 "ease-temp.vala"
		file = (_tmp1_ = g_file_new_for_path (tmp), _g_object_unref0 (file), _tmp1_);
#line 270 "ease-temp.vala"
		g_file_delete (file, NULL, &_inner_error_);
#line 570 "ease-temp.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			goto __catch21_g_error;
		}
		_g_object_unref0 (file);
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	__finally21:
	if (_inner_error_ != NULL) {
		_g_free0 (tmp);
		_g_free0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (tmp);
	_g_free0 (dir);
}


/**
 * Checks if a temporary directory already exists.
 *
 * @param dir The index of the directory.
 * @param tmp The parent temporary directory (typically /tmp/ease).
 */
#line 281 "ease-temp.vala"
gboolean ease_temp_exists (gint dir, const char* tmp) {
#line 608 "ease-temp.c"
	gboolean result = FALSE;
	char* _tmp0_;
	char* _tmp1_;
	char* dir_tmp;
	GFile* file;
#line 281 "ease-temp.vala"
	g_return_val_if_fail (tmp != NULL, FALSE);
#line 283 "ease-temp.vala"
	dir_tmp = (_tmp1_ = g_build_filename (tmp, _tmp0_ = g_strdup_printf ("%i", dir), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 284 "ease-temp.vala"
	file = g_file_new_for_path (dir_tmp);
#line 620 "ease-temp.c"
	result = g_file_query_exists (file, NULL);
	_g_object_unref0 (file);
	_g_free0 (dir_tmp);
#line 286 "ease-temp.vala"
	return result;
#line 626 "ease-temp.c"
}


#line 31 "ease-temp.vala"
EaseTemp* ease_temp_construct (GType object_type) {
#line 632 "ease-temp.c"
	EaseTemp * self;
#line 31 "ease-temp.vala"
	self = (EaseTemp*) g_object_new (object_type, NULL);
#line 636 "ease-temp.c"
	return self;
}


#line 31 "ease-temp.vala"
EaseTemp* ease_temp_new (void) {
#line 31 "ease-temp.vala"
	return ease_temp_construct (EASE_TYPE_TEMP);
#line 645 "ease-temp.c"
}


static const char* ease_temp_get_temp (void) {
	const char* result;
	char* _tmp1_;
	char* _tmp0_;
#line 40 "ease-temp.vala"
	if (ease_temp_m_temp != NULL) {
#line 655 "ease-temp.c"
		result = ease_temp_m_temp;
#line 40 "ease-temp.vala"
		return result;
#line 659 "ease-temp.c"
	}
#line 41 "ease-temp.vala"
	ease_temp_m_temp = (_tmp1_ = g_build_filename (g_get_tmp_dir (), EASE_TEMP_TEMP_DIR, _tmp0_ = g_strdup_printf ("%i", (gint) getpid ()), NULL), _g_free0 (ease_temp_m_temp), _tmp1_);
#line 663 "ease-temp.c"
	_g_free0 (_tmp0_);
	result = ease_temp_m_temp;
#line 43 "ease-temp.vala"
	return result;
#line 668 "ease-temp.c"
}


static GeeLinkedList* ease_temp_get_dirs (void) {
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 52 "ease-temp.vala"
	if (ease_temp_m_dirs != NULL) {
#line 677 "ease-temp.c"
		result = ease_temp_m_dirs;
#line 52 "ease-temp.vala"
		return result;
#line 681 "ease-temp.c"
	}
	result = ease_temp_m_dirs = (_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL), _g_object_unref0 (ease_temp_m_dirs), _tmp0_);
#line 53 "ease-temp.vala"
	return result;
#line 686 "ease-temp.c"
}


static void ease_temp_class_init (EaseTempClass * klass) {
	ease_temp_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = ease_temp_get_property;
	G_OBJECT_CLASS (klass)->finalize = ease_temp_finalize;
}


static void ease_temp_instance_init (EaseTemp * self) {
}


static void ease_temp_finalize (GObject* obj) {
	EaseTemp * self;
	self = EASE_TEMP (obj);
	G_OBJECT_CLASS (ease_temp_parent_class)->finalize (obj);
}


/**
 * Creates temporary directories for use by Ease.
 *
 * Temporary directories are (typically) stored in /tmp/ease/[PID]/[INDEX],
 * where [PID] is the process ID and [INDEX] increments with each new directory.
 * Ease automatically cleans up temporary directories when exiting, and will
 * remove /tmp/ease if no other folders are being used in it.
 *
 * Code that is internal to Ease can also use the request_str() function, which
 * allows a named directory. This is for debugging and cleanliness purposes
 * only - other than the directory name, functionality is identical to
 * request().
 */
GType ease_temp_get_type (void) {
	static volatile gsize ease_temp_type_id__volatile = 0;
	if (g_once_init_enter (&ease_temp_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseTempClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_temp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseTemp), 0, (GInstanceInitFunc) ease_temp_instance_init, NULL };
		GType ease_temp_type_id;
		ease_temp_type_id = g_type_register_static (G_TYPE_OBJECT, "EaseTemp", &g_define_type_info, 0);
		g_once_init_leave (&ease_temp_type_id__volatile, ease_temp_type_id);
	}
	return ease_temp_type_id__volatile;
}


static void ease_temp_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	EaseTemp * self;
	self = EASE_TEMP (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




